:hello                          ; label the "hello world" constant
                                ; The "." indicates that the rest of the line is constant to be put in memory
.hello world.
jmp :begin                      ; Jump over the two subroutines to the start of the main program

:index                          ; label the indexing subroutine that calculates the X,Y position to print at
mult B #80                      ; multiple the B register (holding X) with 80 because there are 80 columns
add B A                         ; add the A register into B to produce "address = (Y * 8) + X"
ret                             ; return to the calling routine. "call" pushes the return address on the stack. "ret" pops the address and jumps to it

:print                          ; label to the print subroutine. The address of the string is in A. The address to print at is in B.
bload C (A)                     ; load C with the value from the address that is held in A
bstore C (B)                    ; store the value in C at the address that is held in B
add A #1                        ; add 1 to the address in A, moving along the NULL terminated string
add B #1                        ; ass 1 to the address in B
cmp C #0                        ; compare the value in C with 0.
ifne :print                     ; If it is not 0, jump to the start of the print subroutine
ret                             ; return

:begin                          ; the start of the main routine
load A #10                      ; put 10 in A, the X position
load B #5                       ; put 5 in B. the Y position
call :index                     ; calculate the video memory address from X and Y, leaving the result in B
load A #:hello                  ; load the address of the "hello" constant string into A
call :print                     ; call the print subroutine
end                             ; end of the program

